﻿------------------------------------------------------------------------------------------
--Shadow Orbs-----------------------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, M, _ = unpack(select(2,...))
local LSM = LibStub("LibSharedMedia-3.0")

local BORDER = 2
local SPELL_POWER_SHADOW_ORBS = SPELL_POWER_SHADOW_ORBS
local SHADOW_ORBS_SHOW_LEVEL = SHADOW_ORBS_SHOW_LEVEL
local PRIEST_BAR_NUM_ORBS = PRIEST_BAR_NUM_ORBS
local UnitPower = UnitPower
local IsAddOnLoaded = IsAddOnLoaded
local collectgarbage = collectgarbage
local unpack = unpack

function SN:SOrbs(frame)
	local CLASSBAR_WIDTH = F.classpower:GetWidth() - (BORDER*2)
	local color = M.classResources.PRIEST

	local shadoworbs = CreateFrame("Frame", nil, frame)
	shadoworbs:SetSize(CLASSBAR_WIDTH, SN.data.profile.classResources.height)
	shadoworbs:SetPoint("CENTER", frame, "CENTER", 0, 0)

	if (IsAddOnLoaded("ElvUI")) then
		SN:SNCreateBG(shadoworbs, "Frame")
	else
		shadoworbs:SetBackdrop({
			bgFile = M.media.blankTex, 
			edgeFile = M.media.blankTex, 
			tile = false, tileSize = 0, edgeSize = 2, 
			insets = { left = 2, right = 2, top = 2, bottom = 2 }
			})
		shadoworbs:SetBackdropColor(0.1, 0.1, 0.1, 1)
		shadoworbs:SetBackdropBorderColor(0.1, 0.1, 0.1, 1)
	end

	for i = 1, PRIEST_BAR_NUM_ORBS do
		shadoworbs[i] = CreateFrame("StatusBar", nil, shadoworbs)
		shadoworbs[i]:SetSize((SN.data.profile.classResources.width - 16) / PRIEST_BAR_NUM_ORBS, SN.data.profile.classResources.height - 6)
		if i == 1 then
			shadoworbs[i]:SetPoint("LEFT", shadoworbs, 3, 0)
		else
			shadoworbs[i]:SetPoint("LEFT", shadoworbs[(i - 1)], "RIGHT", 3, 0)
		end
		shadoworbs[i]:SetStatusBarTexture(LSM:Fetch("statusbar", SN.data.profile.classResources.texture))
		shadoworbs[i]:GetStatusBarTexture():SetHorizTile(false)
		shadoworbs[i]:SetMinMaxValues(0, 1)
		shadoworbs[i]:SetValue(1)
		shadoworbs[i]:SetStatusBarColor(unpack(color))
	end
	
	return shadoworbs
end

function SN:SetupSOrbs()
	if SN.playerClass ~= "PRIEST" then return end
	local frame = F.classpower

	frame.shadoworbs = SN:SOrbs(frame)
	frame.shadoworbs:RegisterEvent("UNIT_DISPLAYPOWER")
	frame.shadoworbs:RegisterEvent("UNIT_POWER_FREQUENT")
	frame.shadoworbs:RegisterEvent("PLAYER_LEVEL_UP")
	frame.shadoworbs:RegisterEvent("PLAYER_TALENT_UPDATE")
	frame.shadoworbs:SetScript("OnEvent", function(self, event, ...)
		local unitID, type = ...
		if unitID == "player" then
			local sOrbs = UnitPower("player", SPELL_POWER_SHADOW_ORBS)
			if sOrbs > 0 then
				for i = 1, PRIEST_BAR_NUM_ORBS do
					self[i]:SetAlpha(0.1)
				end
				for i = 1, sOrbs do
					self[i]:SetAlpha(1)
				end
			else
				for i = 1, PRIEST_BAR_NUM_ORBS do
					self[i]:SetAlpha(0.1)
				end
			end
		end
		local spec = GetSpecialization()
		local level = UnitLevel("player")

		if spec == SPEC_PRIEST_SHADOW and level > SHADOW_ORBS_SHOW_LEVEL then
			SN:SOrbsEnable()
		else
			SN:SOrbsDisable()
		end	
	end)
	local sOrbs = UnitPower("player", SPELL_POWER_SHADOW_ORBS)
	if sOrbs > 0 then
		for i = 1, sOrbs do
			frame.shadoworbs[i]:SetAlpha(1)
		end
	else
		for i = 1, PRIEST_BAR_NUM_ORBS do
			frame.shadoworbs[i]:SetAlpha(0.1)
		end
	end
end

function SN:SOrbsEnable()
	local frame = F.classpower
	frame.shadoworbs:Show()
	frame.shadoworbs:RegisterEvent("UNIT_POWER_FREQUENT")
	frame.shadoworbs:RegisterEvent("PLAYER_LEVEL_UP")
end

function SN:SOrbsDisable()
	local frame = F.classpower
	frame.shadoworbs:UnregisterEvent("UNIT_POWER_FREQUENT")
	frame.shadoworbs:UnregisterEvent("PLAYER_LEVEL_UP")
	frame.shadoworbs:Hide()
	collectgarbage("collect")
end